unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus, XPMan, Tools, ExtCtrls, Gauges,
  ZipThread;

type
  TApp = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    Open1: TMenuItem;
    Resave1: TMenuItem;
    Exit1: TMenuItem;
    Option1: TMenuItem;
    About1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    XPManifest1: TXPManifest;
    OpenFile: TOpenDialog;
    SaveFile: TSaveDialog;
    ZipFile: TButton;
    Gauge1: TGauge;
    SavePath: TEdit;
    OpenPath: TEdit;
    procedure Open1Click(Sender: TObject);
    procedure Resave1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ZipFileClick(Sender: TObject);
    procedure Option1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  App: TApp;thread:Zipping;

implementation

uses OptMenu;

{$R *.dfm}

procedure TApp.Open1Click(Sender: TObject);
begin
if OpenFile.Execute then OpenPath.Text:=OpenFile.FileName;
end;

procedure TApp.Resave1Click(Sender: TObject);
begin
if SaveFile.Execute then SavePath.Text:=SaveFile.FileName;
case SaveFile.FilterIndex of
1:if ExtractFileExt(SaveFile.FileName)<>'.htm' then SavePath.Text:=SavePath.Text+'.htm';
2:if ExtractFileExt(SaveFile.FileName)<>'.html' then SavePath.Text:=SavePath.Text+'.html'
end
end;

procedure TApp.Exit1Click(Sender: TObject);
begin
Application.Terminate
end;

procedure TApp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Application.Terminate
end;

procedure TApp.FormCreate(Sender: TObject);
begin
with Constraints do begin
MaxHeight:=Height;MinHeight:=Height;
MaxWidth:=Width;MinWidth:=Width
end;
OpenFile.InitialDir:=ExtractFileDir(Application.ExeName);
SaveFile.InitialDir:=ExtractFileDir(Application.ExeName);
selectnom:=-1;attrselect:=-1;
safeMSOfficeObjects:=true;
remUnkTags:=false;
remUnkAttrs:=false;
remHardSpace:=false;
remLineFeed:=false;
parseTemplates(ExtractFileDir(Application.ExeName)+'\tmp.ini')
end;

procedure TApp.ZipFileClick(Sender: TObject);
begin
if not FileExists(OpenPath.Text) then begin
ShowMessage('Error:'+#13#10+'Opening file was not found!');
SetFocus;
exit
end;
if thread<>nil then begin thread.Terminate;thread.Destroy end;
thread:=Zipping.Create(false)
end;

procedure TApp.Option1Click(Sender: TObject);
begin
OptApp.Show
end;

procedure TApp.About1Click(Sender: TObject);
begin
ShowMessage(
'WordHTMLZipper'+#13#10+
'Application for hypertext - files zipping.'+#13#10+
'local: En (software)'+#13#10+
'Project author: Pers (pers@mail.ru)'+#13#10+
'Coding: Ershov D.I. (d_ershov@ngs.ru)'
);
SetFocus
end;

end.
