unit OptMenu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Tools, Menus;

type
  TOptApp = class(TForm)
    Load: TButton;
    FilePath: TLabel;
    OpenFile: TOpenDialog;
    TagsList: TListBox;
    Store: TButton;
    SaveFile: TSaveDialog;
    Label2: TLabel;
    Label3: TLabel;
    Cancel: TButton;
    OK: TButton;
    AttrsList: TListBox;
    Label1: TLabel;
    ClassName: TEdit;
    Vis: TCheckBox;
    RemUnTags: TCheckBox;
    RemUnAttrs: TCheckBox;
    AttrCheck: TCheckBox;
    TAName: TEdit;
    Label4: TLabel;
    ATag: TButton;
    AAttr: TButton;
    TagsPopupMenu: TPopupMenu;
    AttrsPopupMenu: TPopupMenu;
    Remove1: TMenuItem;
    Remove2: TMenuItem;
    DAValue: TEdit;
    RemLnFeed: TCheckBox;
    RemNBSP: TCheckBox;
    procedure LoadClick(Sender: TObject);
    procedure TagsListClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure VisClick(Sender: TObject);
    procedure ClassNameChange(Sender: TObject);
    procedure StoreClick(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure AttrsListClick(Sender: TObject);
    procedure AttrCheckClick(Sender: TObject);
    procedure ATagClick(Sender: TObject);
    procedure AAttrClick(Sender: TObject);
    procedure Remove1Click(Sender: TObject);
    procedure Remove2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DAValueChange(Sender: TObject);
  private
    { Private declarations }
  public
  procedure LoadTemplatesList;
    { Public declarations }
  end;

var
  OptApp: TOptApp;selectnom,attrselect:integer;loading:boolean;
  Tpl:array of TagTemplate;

  procedure AttachTemplates;
  procedure DetachTemplates;

implementation

{$R *.dfm}

procedure TOptApp.LoadClick(Sender: TObject);
begin
if not OpenFile.Execute then exit;
FilePath.Caption:=OpenFile.FileName;
parseTemplates(FilePath.Caption);
AttachTemplates;
LoadTemplatesList
//;ShowTemplates
end;

procedure TOptApp.LoadTemplatesList;
var i:integer;
begin
TagsList.ClearSelection;
TagsList.Clear;
AttrsList.ClearSelection;
AttrsList.Clear;
loading:=true;
ClassName.Text:='';Vis.Checked:=false;
loading:=false;
for i:=0 to length(Tpl)-1 do TagsList.Items.Append(Tpl[i].name)
end;

procedure TOptApp.TagsListClick(Sender: TObject);
var i,j:integer;
begin
AttrsList.Clear;
i:=0;
repeat
if TagsList.Selected[i] then break;
inc(i)
until i>=TagsList.Items.Count;
if i>=TagsList.Items.Count then begin selectnom:=-1;exit end;
selectnom:=i;
for j:=0 to length(Tpl[i].attr)-1 do AttrsList.Items.Append(Tpl[i].attr[j].name);
ClassName.Text:=Tpl[i].clas;
Vis.Checked:=Tpl[i].visible
end;

function correctTAName:boolean;
var s:string;i:integer;
begin
s:=OptApp.TAName.Text;
Result:=true;
if length(s)=0 then begin Result:=false;exit end;
for i:=1 to length(s) do
if not (s[i] in ['A'..'Z','a'..'z','_']) then begin Result:=false;break end
end;

procedure TOptApp.FormShow(Sender: TObject);
begin
AttachTemplates;
LoadTemplatesList
end;

procedure TOptApp.CancelClick(Sender: TObject);
begin
RemUnTags.Checked:=remUnkTags;
RemUnAttrs.Checked:=remUnkAttrs;
RemNBSP.Checked:=remHardSpace;
RemLnFeed.Checked:=remLineFeed;
Hide
end;

procedure TOptApp.VisClick(Sender: TObject);
begin
if selectnom=-1 then exit;
if not loading then begin
//ShowMessage(Tpl[selectnom].name+': '+BoolToStr(Vis.Checked));
Tpl[selectnom].visible:=Vis.Checked end;
end;

procedure TOptApp.ClassNameChange(Sender: TObject);
begin
if not loading then Tpl[selectnom].clas:=ClassName.Text
end;

procedure TOptApp.StoreClick(Sender: TObject);
var f:textfile;i,j:integer;
begin
if not SaveFile.Execute then exit;
DetachTemplates;
FilePath.Caption:=SaveFile.FileName;
assignfile(f,FilePath.Caption);rewrite(f);
for i:=0 to length(Tmp)-1 do begin
writeln(f,'['+Tmp[i].name+']');
write(f,'visible=');
if Tmp[i].visible then writeln(f,'on') else writeln(f,'off');
if length(Tmp[i].clas)>0 then writeln(f,'class='+Tmp[i].clas);
for j:=0 to length(Tmp[i].attr)-1 do
writeln(f,Tmp[i].attr[j].name+'='+Tmp[i].attr[j].value)
end;
closefile(f)
end;

procedure AttachTemplates;
var i:integer;
begin
SetLength(Tpl,length(Tmp));
for i:=0 to length(Tmp)-1 do Tpl[i]:=Tmp[i]
end;

procedure DetachTemplates;
var i:integer;
begin
SetLength(Tmp,length(Tpl));
for i:=0 to length(Tpl)-1 do Tmp[i]:=Tpl[i]
end;

procedure TOptApp.OKClick(Sender: TObject);
begin
remUnkTags:=RemUnTags.Checked;
remUnkAttrs:=RemUnAttrs.Checked;
remHardSpace:=RemNBSP.Checked;
remLineFeed:=RemLnFeed.Checked;
DetachTemplates;
Hide
end;

procedure TOptApp.AttrsListClick(Sender: TObject);
var i:integer;
begin
i:=0;
repeat
if AttrsList.Selected[i] then break;
inc(i)
until i>=AttrsList.Items.Count;
if i>=AttrsList.Items.Count then begin
attrselect:=-1;AttrCheck.Checked:=false;exit end;
attrselect:=i;
//AttrCheck.Checked:=Tpl[selectnom].attr[i].value='on';
DAValue.Text:=Tpl[selectnom].attr[i].value
end;

procedure TOptApp.AttrCheckClick(Sender: TObject);
begin
if attrselect=-1 then exit;
if AttrCheck.Checked then
Tpl[selectnom].attr[attrselect].value:='on' else
Tpl[selectnom].attr[attrselect].value:='off';
loading:=true;
DAValue.Text:=Tpl[selectnom].attr[attrselect].value;
loading:=false
end;

procedure TOptApp.ATagClick(Sender: TObject);
var tag:TagTemplate;
begin
if not correctTAName then exit;
SetLength(Tpl,length(Tpl)+1);
tag.name:=TAName.Text;tag.visible:=false;
Tpl[length(Tpl)-1]:=tag;
TagsList.Items.Append(tag.name)
end;

procedure TOptApp.AAttrClick(Sender: TObject);
var attr:Attribute;
begin
if not correctTAName or (selectnom=-1) then exit;
SetLength(Tpl[selectnom].attr,length(Tpl[selectnom].attr)+1);
attr.name:=TAName.Text;attr.value:='off';
Tpl[selectnom].attr[length(Tpl[selectnom].attr)-1]:=attr;
AttrsList.Items.Append(attr.name)
end;

procedure TOptApp.Remove1Click(Sender: TObject);
var i:integer;
begin
if selectnom=-1 then exit;
for i:=selectnom+1 to length(Tpl)-1 do Tpl[i-1]:=Tpl[i];
SetLength(Tpl,length(Tpl)-1);
TagsList.Items.Delete(selectnom);
//DetachTemplates
end;

procedure TOptApp.Remove2Click(Sender: TObject);
var i:integer;
begin
if (selectnom=-1) or (attrselect=-1) or not AttrsList.Focused then exit;
for i:=attrselect+1 to length(Tpl[selectnom].attr)-1 do
Tpl[selectnom].attr[i-1]:=Tpl[selectnom].attr[i];
SetLength(Tpl[selectnom].attr,length(Tpl[selectnom].attr)-1);
AttrsList.Items.Delete(attrselect);
//DetachTemplates
end;

procedure TOptApp.FormCreate(Sender: TObject);
begin
with Constraints do begin
MaxHeight:=Height;MinHeight:=Height;
MaxWidth:=Width;MinWidth:=Width
end;
OpenFile.InitialDir:=ExtractFileDir(Application.ExeName);
SaveFile.InitialDir:=ExtractFileDir(Application.ExeName);
FilePath.Caption:=ExtractFileDir(Application.ExeName)+'\tmp.ini'
end;

procedure TOptApp.DAValueChange(Sender: TObject);
begin
if loading then exit;
if (DAValue.Text='on')or(DAValue.Text='off') then begin
AttrCheck.Enabled:=true;
AttrCheck.Checked:=DAValue.Text='on'
end else if (selectnom<>-1)and(attrselect<>-1) then begin
AttrCheck.Enabled:=false;
Tpl[selectnom].attr[attrselect].value:=DAValue.Text
end
end;

end.
