unit Tools;

interface

uses inifiles,sysutils,classes,dialogs,stdctrls;

const protectTag:array[1..9] of string=(
      'script',
      'noscript',
      'frame',
      'noframes',
      'frameset',
      'iframe',
      'pre',
      'html',
      'body'
      );


type Attribute=record
     name:string;
     value:string
     end;
type TagInfo=record
     name,clas:string;
     attr:array of Attribute
     end;
type TagTemplate=record
     visible:boolean;
     name,clas:string;
     attr:array of Attribute
     end;

var Tmp:array of TagTemplate;
    f,g:file of char;
    remUnkTags,remUnkAttrs,remHardSpace,remLineFeed,safeMSOfficeObjects:boolean;

procedure parseTemplates(TemplateList:string);
procedure loadDefaultTemplateList;
procedure ZipHTMLFile(src,dst:string);


procedure showTemplates;
implementation

uses MainUnit, OptMenu;

procedure loadDefaultTemplateList;
begin
ShowMessage('Load the default templates');
end;

function isValidValue(v:string):boolean;
var res:boolean;i:integer;
begin
res:=true;
for i:=2 to length(v)-1 do if not(v[i] in ['A'..'Z','a'..'z','0'..'9','_']) then
begin res:=false;break end;
isValidValue:=res
end;

function SkipComment:string;
var buf:string[3];s:char;text:string;
begin
buf:='--[';
read(f,s);if s<>'[' then begin
{If it isn`t shell comment}
while buf<>'-->' do begin
read(f,s);
buf[1]:=buf[2];buf[2]:=buf[3];buf[3]:=s
end;SkipComment:=''
end else begin
{If it`s shell comment}
text:='!--[';
while buf<>'-->' do begin
read(f,s);
buf[1]:=buf[2];buf[2]:=buf[3];buf[3]:=s;text:=text+s
end;
SkipComment:=copy(text,1,length(text)-1)
end end;

function readTag:TagInfo;
var s,fr:char;t:string;tag:TagInfo;a:Attribute;
begin
try
t:='';read(f,s);
{Read tag name}
while not (s in [' ','>',#10,#13,#9]) do begin
t:=t+s;
{If it is comment}
if length(t)=3 then if t='!--' then begin tag.name:=SkipComment;readTag:=tag;exit end;
{But if it`s false then countinue}
read(f,s)
end;
tag.name:=t;
{Exit if '>' was occur}
if s='>' then begin readTag:=tag;exit end;
{Read attributes}
SetLength(tag.attr,0);
repeat
{Skip not needed characters}
while s in [' ','/',#10,#13,#9] do read(f,s);
if s='>' then break;
{Read attribute name}
t:='';
while not (s in ['=',' ','/','>',#10,#13,#9]) do begin
t:=t+s;read(f,s)
end;
a.name:=t;
{Read attribute value}
if s='=' then begin
t:='';read(f,s);
if s in ['''','"'] then begin
fr:=s;t:=t+s;read(f,s);t:=t+s;read(f,s);
while t[length(t)]<>fr do begin
t:=t+s;read(f,s)
end
end else
while not (s in [' ','/','>',#10,#13,#9]) do begin
t:=t+s;read(f,s)
end;
a.value:=t;
if (a.value[1] in ['"','''']) and isValidValue(a.value)
then a.value:=copy(a.value,2,length(a.value)-2);
end else a.value:='';
{Append new attribute}
if a.name='class' then tag.clas:=a.value else
begin
SetLength(tag.attr,length(tag.attr)+1);
tag.attr[length(tag.attr)-1]:=a
end
until false;
readTag:=tag
except
ShowMessage('Error when read tag!!!')
end
end;

procedure parseTemplates;
var d:TIniFile;slist,klist:TStringList;tag:TagTemplate;a:Attribute;
    i,j,q,p:integer;
begin
try
{If template-file is not exists then load default template list}
if not FileExists(TemplateList) then begin loadDefaultTemplateList;exit end;
{Connect to template ini-file}
d:=TIniFile.Create(TemplateList);
slist:=TStringList.Create;
klist:=TStringList.Create;
{Read sections list}
d.ReadSections(slist);
SetLength(Tmp,0);i:=0;
{Enumirate sections}
for q:=0 to slist.Count-1 do begin
//if d.ReadString(slist.Strings[q],'visible','off')='off' then continue;
tag.visible:=d.ReadString(slist.Strings[q],'visible','off')='on';
inc(i);SetLength(Tmp,i);
tag.name:=slist.Strings[q];
{Read current section}
d.ReadSection(tag.name,klist);
SetLength(tag.attr,0);j:=0;tag.clas:='';
{Enumirate keys of current section}
for p:=0 to klist.Count-1 do
{Read tag class}
if klist.Strings[p]='class' then tag.clas:=d.ReadString(tag.name,'class','') else
{Read attribute}
if not (klist.Strings[p]='visible') {and (d.ReadString(tag.name,klist.Strings[p],'off')='on')} then
begin
inc(j);SetLength(tag.attr,j);
a.name:=klist.Strings[p];
a.value:=d.ReadString(tag.name,a.name,'off');
tag.attr[j-1]:=a
end;
klist.Clear;
Tmp[i-1]:=tag
end;
slist.Clear;
d.Free
except
ShowMessage('Error when parse template!!!')
end
end;

function convertTag(ins:TagInfo):string;
var tag:string;i:integer;
begin
if ins.name='' then begin convertTag:='';exit end;
tag:='<'+ins.name;
if length(ins.clas)>0 then tag:=tag+' class='+ins.clas;
for i:=0 to length(ins.attr)-1 do begin
tag:=tag+' '+ins.attr[i].name;
if length(ins.attr[i].value)>0 then tag:=tag+'='+ins.attr[i].value
end;
convertTag:=tag+'>'
end;

procedure store(sstr:string);
var i:integer;
begin
for i:=1 to length(sstr) do write(g,sstr[i])
end;

procedure AdvZipHTMLHead;
var s:char;t:TagInfo;EOGraphicsSection,CloseTitle:boolean;
begin
try
{Skip <html ... >}
s:=chr(0);
while s<>'>' do begin read(f,s);write(g,s) end;
{Advanced zipping of html-file head}
t.name:='';EOGraphicsSection:=false;CloseTitle:=false;
while t.name<>'body' do begin
read(f,s);
{Found open bound}
if s='<' then begin t:=readTag;
{Save obligate tags}
if (t.name='head') or (t.name='/head') or (t.name='body') or (t.name='title') or (t.name='/title')
then store('<'+t.name+'>');
{Check graphics section}
EOGraphicsSection:=EOGraphicsSection or (t.name='title');
if not CloseTitle then CloseTitle:=CloseTitle or (t.name='/title');
{Save graphics parameters}
if not EOGraphicsSection then if copy(t.name,1,4)='!--[' then store(convertTag(t));
end else if EOGraphicsSection and not CloseTitle then write(g,s);
end
except
ShowMessage('Error when zip head section!')
end
end;

procedure ZipHTMLHead;
var s:char;t,head:string;
begin
try
t:='';read(f,s);head:='';
repeat
while s<>'<' do read(f,s);
t:='';read(f,s);
while not (s in [' ','>',#10,#13,#9]) do begin
t:=t+s;read(f,s)
end;
if (t='title') or (t='body') then begin
while s<>'>' do read(f,s);
if t='title' then begin
read(f,s);
while s<>'<' do begin
head:=head+s;read(f,s)
end end
end
until t='body';
store('<html><head><title>'+head+'</title></head>'+#13#10+'<body>')
except
ShowMessage('Error when zip head section!')
end
end;

function isProtectTag(tname:string):boolean;
var res:boolean;i:integer;
begin
res:=false;
for i:=1 to 9 do begin
res:=res or (tname=protectTag[i]) or (tname='/'+protectTag[i]);
if res then break
end;
isProtectTag:=res
end;

procedure compareWithTemplates(var tag:TagInfo);
var newAttr:array of Attribute;i,j,k,l:integer;
begin
try
if (tag.name='') or (copy(tag.name,1,4)='!--[')or (copy(tag.name,1,2)='![') then exit else
if (tag.name='br') and remLineFeed then begin tag.name:='';exit end;
{Found needed template}
i:=0;
repeat
{If needed template was found}
if (tag.name=Tmp[i].name) or (tag.name='/'+Tmp[i].name) then break;
inc(i)
until i>=length(Tmp);
{If needed template was not found}
if (i=length(Tmp)) or not Tmp[i].visible then begin
if RemUnkTags and (i=length(Tmp)) and not isProtectTag(tag.name) then begin
{Remove if it`s not needed for safing of MSOffice objects when once is enable}
{if not (tag.name[1] in ['o','/','!']) then} tag.name:=''
end;
exit
end;
{Set default class}
if tag.name[1]<>'/' then begin tag.clas:=Tmp[i].clas end else exit;
{Clear attributes list}
//if length(Tmp[i].attr)=0 then exit;
SetLength(newAttr,0);l:=0;
for j:=0 to length(tag.attr)-1 do
begin
k:=0;
if length(Tmp[i].attr)>0 then
repeat
if tag.attr[j].name=Tmp[i].attr[k].name then break;
inc(k)
until k>=length(Tmp[i].attr);
if (k>=length(Tmp[i].attr)) and RemUnkAttrs then continue;
if (k>=length(Tmp[i].attr)) or (Tmp[i].attr[k].value<>'off') then begin
inc(l);SetLength(newAttr,l);newAttr[l-1]:=tag.attr[j];
{Set default tag value}
if k<length(Tmp[i].attr) then
if (Tmp[i].attr[k].value<>'on') then newAttr[l-1].value:=Tmp[i].attr[k].value;
end
end;
{Rewrite tag attributes list}
SetLength(tag.attr,length(newAttr));
for i:=0 to length(newAttr)-1 do tag.attr[i]:=newAttr[i]
except
ShowMessage('Error when compare with template: '+convertTag(tag))
end
end;

procedure ZipHTMLFile;
const nbsp:string[5]='nbsp;';space:char=' ';
var s:char;t:TagInfo;i:integer;buf:string;
begin
assignfile(f,src);assignfile(g,dst);
reset(f);rewrite(g);
{Clear HTML - file head}
if safeMSOfficeObjects then AdvZipHTMLHead else ZipHTMLHead;
{Clear last part of HTML - document}
while not eof(f) do begin
read(f,s);
{Clear hard spaces}
if (s='&') and remHardSpace then repeat
buf:='';
for i:=1 to 5 do begin
read(f,s);buf:=buf+s;
if s<>nbsp[i] then begin store('&'+buf);break end
end;
if nbsp=buf then begin write(g,space);read(f,s) end else
if s<>'<' then read(f,s)
until s<>'&';
{Clear tags}
if s<>'<' then write(g,s) else begin t:=readTag;
compareWithTemplates(t);
store(convertTag(t));
App.Gauge1.Progress:=trunc(filepos(f)*100/filesize(f))
end end;App.Gauge1.Progress:=100;
{Over of process}
ShowMessage('Zipping completed.');
App.Gauge1.Progress:=0;
closefile(f);closefile(g)
end;

procedure showTemplates;
var i,j:integer;msg:string;
begin
msg:='';
for i:=0 to length(Tmp)-1 do begin
msg:=msg+'template#'+IntToStr(i)+#10#13+Tmp[i].name+#10#13+Tmp[i].clas+#10#13;
for j:=0 to length(Tmp[i].attr)-1 do
msg:=msg+Tmp[i].attr[j].name+'='+Tmp[i].attr[j].value+#10#13
end;
ShowMessage(msg)
end;

end.
